/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(["sap/ui/core/format/DateFormat","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/v4/lib/_Helper"],function(D,B,_){"use strict";var d="\\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\\d|3[01])",t="(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(\\.\\d{1,12})?)?",r=new RegExp("^"+d+"$"),a=new RegExp("^"+d+"T"+t+"(?:Z|[-+](?:0\\d|1[0-3]):[0-5]\\d|[-+]14:00)$","i"),b=new RegExp("^"+t+"$"),O={compare:function(v,V,e){if(e===true||e==="Decimal"){return B.compare(v,V,true);}if(e==="DateTime"){return B.compare(O.parseDateTimeOffset(v),O.parseDateTimeOffset(V));}return B.compare(v,V);},parseDate:function(s){var o=r.test(s)&&D.getDateInstance({pattern:"yyyy-MM-dd",strictParsing:true,UTC:true}).parse(s);if(!o){throw new Error("Not a valid Edm.Date value: "+s);}return o;},parseDateTimeOffset:function(s){var o,m=a.exec(s);if(m){if(m[1]&&m[1].length>4){s=s.replace(m[1],m[1].slice(0,4));}o=D.getDateTimeInstance({pattern:"yyyy-MM-dd'T'HH:mm:ss.SSSX",strictParsing:true}).parse(s.toUpperCase());}if(!o){throw new Error("Not a valid Edm.DateTimeOffset value: "+s);}return o;},parseTimeOfDay:function(T){var o;if(b.test(T)){if(T.length>12){T=T.slice(0,12);}o=D.getTimeInstance({pattern:"HH:mm:ss.SSS",strictParsing:true,UTC:true}).parse(T);}if(!o){throw new Error("Not a valid Edm.TimeOfDay value: "+T);}return o;},formatLiteral:function(v,T){return _.formatLiteral(v,T);}};return O;},true);
